<template>
  <div class="widget-calendar-new">
    <div v-if="showMD" class="row">
      <div v-if="A" class="col-md-6">
        <div class="aspect-box wide min-height">
          <div class="aspect-container">
            <event-card
              :event-entry="A"
              :box-max-col="2"
              width-class="w-75"
            ></event-card>
          </div>
        </div>
      </div>
      <div v-if="B" class="col-md-6 mt-4 mt-md-0">
        <div class="aspect-box wide min-height">
          <div class="aspect-container">
            <event-card
              :event-entry="B"
              :box-max-col="2"
              width-class="w-75"
            ></event-card>
          </div>
        </div>
      </div>
    </div>
    <div v-if="showSM" :class="{ 'mt-4': showMD }" class="row">
      <div v-if="C" class="col-sm-6 col-lg-3">
        <div class="aspect-box min-height">
          <div class="aspect-container">
            <event-card :event-entry="C" :box-max-col="4"></event-card>
          </div>
        </div>
      </div>
      <div v-if="D" class="col-sm-6 col-lg-3 mt-4 mt-sm-0">
        <div class="aspect-box min-height">
          <div class="aspect-container">
            <event-card :event-entry="D" :box-max-col="4"></event-card>
          </div>
        </div>
      </div>
      <div v-if="E" class="col-sm-6 col-lg-3 mt-4 mt-md-0">
        <div class="aspect-box min-height">
          <div class="aspect-container">
            <event-card :event-entry="E" :box-max-col="4"></event-card>
          </div>
        </div>
      </div>
      <div v-if="F" class="col-sm-6 col-lg-3 mt-4 mt-md-0">
        <div class="aspect-box min-height">
          <div class="aspect-container">
            <event-card :event-entry="F" :box-max-col="4"></event-card>
          </div>
        </div>
      </div>
    </div>
    <div v-if="showXL" :class="{ 'mt-4': showMD || showSM }" class="row">
      <div v-if="G" class="col-12">
        <div class="aspect-box ultra-wide min-height">
          <div class="aspect-container">
            <event-card
              :event-entry="G"
              :box-max-col="1"
              width-class="w-50"
            ></event-card>
          </div>
        </div>
      </div>
    </div>
    <div v-if="hasEvents" class="mt-2">
      <font-awesome-icon
        :icon="['fas', 'info-circle']"
        class="mr-1"
      ></font-awesome-icon
      >{{ $t('events.info.timezone')
      }}<span class="ie_hidden"
        >: {{ Intl.DateTimeFormat().resolvedOptions().timeZone }}</span
      >
    </div>
    <div v-else class="mt-2">
      {{ $t('events.noEvents') }}
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import EventCard from '~/components/cards/event-card';
import DateTimeFormatMixin from '~/components/mixins/DateTimeFormatMixin';
export default {
  components: { EventCard },
  mixins: [DateTimeFormatMixin],
  data() {
    return {
      A: null,
      B: null,
      C: null,
      D: null,
      E: null,
      F: null,
      G: null,
      disablePoolSM: false,
      disablePoolMD: false,
      disablePoolXL: false,
    };
  },
  computed: {
    ...mapGetters('events', ['getEvents', 'getEventsLoadingStatus']),
    showMD() {
      return !this.disablePoolMD;
    },
    showSM() {
      return !this.disablePoolSM;
    },
    showXL() {
      return !this.disablePoolXL;
    },
    hasEvents() {
      return this.showMD || this.showSM || this.showXL;
    },
  },
  mounted() {
    if (!this.getEventsLoadingStatus) {
      this.loadEvents();
    }

    this._populateEvents();
  },
  methods: {
    async loadEvents() {
      await this.$store.dispatch('events/loadEvents');
    },
    _reorderPools(p1, p2, targetSize) {
      /* if (p1.length > targetSize) {
        p1.forEach((entry, index) => {
          if (index > targetSize - 1) {
            p2.push(entry);
          }
        });
      } */

      const keep = [];

      while (p1.length > targetSize) {
        const elem = p1.pop();
        if (elem.lockSize === true) {
          keep.push(elem);
        } else {
          p2.push(elem);
        }
      }

      keep.forEach((elem) => {
        p1.push(elem);
      });
    },
    _sortPool(p) {
      return p.sort((a, b) => {
        const d1 = new Date(this.getCorrectTimeFormat(a.dateStart));
        const d2 = new Date(this.getCorrectTimeFormat(b.dateStart));

        if (d1.getTime() < d2.getTime()) {
          return -1;
        }
        if (d1.getTime() > d2.getTime()) {
          return 1;
        }
        // a must be equal to b
        return 0;
      });
    },
    _populateEvents() {
      const pools = {
        sm: [],
        md: [],
        xl: [],
      };

      this.getEvents.forEach((entry) => {
        if (entry.preferredSize === 'xl') {
          pools.xl.push(entry);
        } else if (entry.preferredSize === 'md') {
          pools.md.push(entry);
        } else {
          pools.sm.push(entry);
        }
      });

      pools.sm = this._sortPool(pools.sm);
      pools.md = this._sortPool(pools.md);
      pools.xl = this._sortPool(pools.xl);

      // balance if pool too empty and other too full or so
      this._reorderPools(pools.xl, pools.sm, 1);
      pools.sm = this._sortPool(pools.sm);

      this._reorderPools(pools.sm, pools.md, 4);
      pools.md = this._sortPool(pools.md);

      this._reorderPools(pools.md, pools.sm, 2);
      pools.sm = this._sortPool(pools.sm);

      this._reorderPools(pools.sm, pools.xl, 4);
      pools.xl = this._sortPool(pools.xl);

      this.disablePoolSM = false;
      this.disablePoolMD = false;
      this.disablePoolXL = false;
      if (pools.sm.length === 0) {
        this.disablePoolSM = true;
      }
      if (pools.md.length === 0) {
        this.disablePoolMD = true;
      }
      if (pools.xl.length === 0) {
        this.disablePoolXL = true;
      }

      this.A = pools.md[0];
      this.B = pools.md[1];
      this.C = pools.sm[0];
      this.D = pools.sm[1];
      this.E = pools.sm[2];
      this.F = pools.sm[3];
      this.G = pools.xl[0];
    },
  },
};
</script>
